# GoogleEarthEnterpriseTerrainProvider

#### new Cesium.GoogleEarthEnterpriseTerrainProvider(options)
Core/GoogleEarthEnterpriseTerrainProvider.js 93

Provides tiled terrain using the Google Earth Enterprise REST API.

Name | Type | Description
--- | --- | ---
`options` | Object | Object with the following properties:
Name | Type | Description
--- | --- | ---
`url` | Resource | String | The url of the Google Earth Enterprise server hosting the imagery.
`metadata` | GoogleEarthEnterpriseMetadata | A metadata object that can be used to share metadata requests with a GoogleEarthEnterpriseImageryProvider.
`ellipsoid` | Ellipsoid | optional The ellipsoid. If not specified, the WGS84 ellipsoid is used.
`credit` | Credit | String | optional A credit for the data source, which is displayed on the canvas.

##### Example:

    var geeMetadata = new GoogleEarthEnterpriseMetadata('http://www.earthenterprise.org/3d');
    var gee = new Cesium.GoogleEarthEnterpriseTerrainProvider({
        metadata : geeMetadata
    });

##### See:

- GoogleEarthEnterpriseImageryProvider
- CesiumTerrainProvider
- Cross-Origin Resource Sharing

### Members

#### readonly availability : TileAvailability
Core/GoogleEarthEnterpriseTerrainProvider.js 313

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This function should not be called before `GoogleEarthEnterpriseTerrainProvider#ready` returns true. This property may be undefined if availability information is not available.

#### readonly credit : Credit
Core/GoogleEarthEnterpriseTerrainProvider.js 270

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain. This function should not be called before `GoogleEarthEnterpriseTerrainProvider#ready` returns true.

#### readonly errorEvent : Event
Core/GoogleEarthEnterpriseTerrainProvider.js 233

Gets an event that is raised when the imagery provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasVertexNormals : Boolean
Core/GoogleEarthEnterpriseTerrainProvider.js 298

Gets a value indicating whether or not the requested tiles include vertex normals. This function should not be called before `GoogleEarthEnterpriseTerrainProvider#ready` returns true.

#### readonly hasWaterMask : Boolean
Core/GoogleEarthEnterpriseTerrainProvider.js 285

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves. This function should not be called before `GoogleEarthEnterpriseTerrainProvider#ready` returns true.

#### readonly proxy : Proxy
Core/GoogleEarthEnterpriseTerrainProvider.js 198

Gets the proxy used by this provider.

#### readonly ready : Boolean
Core/GoogleEarthEnterpriseTerrainProvider.js 245

Gets a value indicating whether or not the provider is ready for use.

#### readonly readyPromise : Promise.<Boolean>
Core/GoogleEarthEnterpriseTerrainProvider.js 257

Gets a promise that resolves to true when the provider is ready for use.

#### readonly tilingScheme : TilingScheme
Core/GoogleEarthEnterpriseTerrainProvider.js 211

Gets the tiling scheme used by this provider. This function should not be called before `GoogleEarthEnterpriseTerrainProvider#ready` returns true.

#### readonly url : String
Core/GoogleEarthEnterpriseTerrainProvider.js 186

Gets the name of the Google Earth Enterprise server url hosting the imagery.

### Methods

#### getLevelMaximumGeometricError(level) → Number
Core/GoogleEarthEnterpriseTerrainProvider.js 553

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | Number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → Boolean|undefined
Core/GoogleEarthEnterpriseTerrainProvider.js 567

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise.<void>
Core/GoogleEarthEnterpriseTerrainProvider.js 624

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
Core/GoogleEarthEnterpriseTerrainProvider.js 357

Requests the geometry for a given tile. This function should not be called before `GoogleEarthEnterpriseTerrainProvider#ready` returns true. The result must include terrain data and may optionally include a water mask and an indication of which child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

##### Throws:

- DeveloperError : This function must not be called before `GoogleEarthEnterpriseTerrainProvider#ready` returns true.